; EX4_asm

	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX4 v1.04"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

id	equ	0
sprad	equ	4
inf_xp	equ	8
inf_yp	equ	$0A
inf_xz	equ	$0C
inf_yz	equ	$0E
th_xp	equ	$10
th_yp	equ	$12
block	equ	$14
pos	equ	$1C
cite	equ	$20
liset	equ	$22

th_xz	equ	24
th_yz	equ	12

*
start	lea	(a6,a4.l),a6	dataspace
	move.l	#ww0_0,d1 	size for window
	bsr	getsp		A0 -> space
	movea.l	a0,a4
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,sprad(a6)	test WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2

; We need to clear the status area and set the loose items
; to "available" (ie zero)

	lea	wst0,a1		Status . .
	movea.l	a1,a0		. . area
	moveq	#wst0_e-wst0-1,d1	Size to clear - 1
st1	clr.b	(a0)+
	dbf	d1,st1
	movea.l	id(a6),a0 	Replace the channel ID
	moveq	#0,d1		default size
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
	move.l	ww_psprt(a4),sprad(a6)
	movea.l	ww_pinfo(a4),a5	Address of inf list
	lea	wwi_elen(a5),a5	-> 2nd window
	move.l	wwi_xorg(a5),inf_xp(a6)
	move.l	wwi_xsiz(a5),inf_xz(a6)
	move.l	#$A000A,th_xp(a6)
	pea	7		white
	bsr	prt_bl
	addq.l	#4,a7
	movea.l	(a4),a1		-> status area
	bsr	setf
wrpt
	moveq	#11,d2		keypress or move
	move.l	pos(a6),d1	current position
	bsr	rdptrt
	cmp.l	pos(a6),d1
	beq	st2		keypress
	move.l	d1,pos(a6)
	bsr	chkin
	bra	wrpt

; Keypress - ESC,  CTRL/F4 (move), HIT or DO

st2	move.b	wsp_kstr(a1),d0
	cmpi.b	#27,d0
	beq	sui		EXIT
	cmpi.b	#$F5,d0		CTRL/F4 (move)? . .
	bne	st3		. . no
st4	bsr	move1
	bra	wrpt
st3
	subq.b	#3,d0
	bhi	wrpt		not 1 or 2 (HIT or DO)

; Do Action
	move.w	cite(a6),d1	current item
	bmi	chkth		move block or nothing
	beq	st4		move
	bra	sui		EXIT


move1	move.b	#129,d3
	bsr	ldrw
	bsr	move
	moveq	#1,d3
	bsr	ldrw
	bra	setf

chkth	addq.b	#2,d0
	bne	wrpt		Not HIT
	move.l	th_xp(a6),d1
	add.l	inf_xp(a6),d1	origin
	moveq	#th_xz,d2
	swap	d2
	move.w	#th_yz,d2
	bsr	isin
	bne	wrpt		not in
	pea	2		red
	bsr	prt_bl		set window and print block
	addq.l	#4,a7
	lea	cpt_nul_spr,a5
	move.l	a5,ww_psprt(a4)	set null sprite

; set max and min positions in D4 and D5

	move.w	pos(a6),d4
	add.w	inf_xz(a6),d4
	sub.w	th_xp(a6),d4
	subi.w	#th_xz,d4
	swap	d4
	move.w	pos+2(a6),d4
	add.w	inf_yz(a6),d4
	sub.w	th_yp(a6),d4
	subi.w	#th_yz,d4
	move.w	pos(a6),d5
	sub.w	th_xp(a6),d5
	swap	d5
	move.w	pos+2(a6),d5
	sub.w	th_yp(a6),d5

chkth_1	move.l	pos(a6),d7	old position kept in D7
	moveq	#0,d6		chps in D6
	bset	#31,d6
	move.l	d7,d1		old position
	moveq	#12,d2		movement or key up
	bsr	rdptr
	cmp.l	d1,d7
	beq	chkth_2		done
chkth_6	cmp.w	d1,d4
	bge	chkth_3
	move.w	d4,d1
	addq.w	#1,d6
	bra	chkth_5
chkth_3	cmp.w	d1,d5
	ble	chkth_5
	move.w	d5,d1
	addq.w	#1,d6
chkth_5	swap	d1
	swap	d4
	swap	d5
	bclr	#31,d6
	bne	chkth_6		now do x-values
	move.l	d1,pos(a6)	set new position
	tst.w	d6
	beq	chkth_7		no forcing
	moveq	#0,d2		absolute position
	moveq	#iop_sptr,d0
	trap	#3
chkth_7	cmp.l	d1,d7
	beq	chkth_1		read again
	pea	5		cyan
	bsr	prt_bl1		print block
	addq.l	#4,a7
	move.l	th_xp(a6),d0
	add.l	pos(a6),d0
	sub.l	d7,d0
	move.l	d0,th_xp(a6)	update th_xp and th_yp
	pea	5		cyan
	bsr	prt_bl1
	addq.l	#4,a7
	bra	chkth_1

chkth_2	pea	2		red
	bsr	prt_bl1
	addq.l	#4,a7
	move.l	sprad(a6),ww_psprt(a4)	reset sprite
	movea.l	(a4),a1		-> status area
	bra	wrpt



*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#-1,d1		. . for this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	rts





; prt_bl1 prints the block to information window 1
; The colour is on the stack (long word)
; prt_bl does the same but sets the window first (and sets D3 to -1)

prt_bl	moveq	#1,d1		information window 1
	moveq	#-1,d2		no colours or OVER set
	jsr	wm_swinf(a2)	set window to inf 1
	moveq	#-1,d1		OVER -1
	bsr	overt

prt_bl1	move.l	a1,-(a7)
	move.w	#th_xz,block(a6)
	move.w	#1,block+2(a6)
	move.w	th_xp(a6),block+4(a6)
	move.w	th_yp(a6),block+6(a6)
	bsr	blk
	addi.w	#th_yz-1,block+6(a6)
	bsr	blk
	move.w	#1,block(a6)
	move.w	#th_yz-2,block+2(a6)
	move.w	th_xp(a6),block+4(a6)
	move.w	th_yp(a6),block+6(a6)
	addq.w	#1,block+6(a6)
	bsr	blk
	addi.w	#th_xz-1,block+4(a6)
	bsr	blk
	movea.l	(a7)+,a1
	rts



; setf sets borders round loose items. Used at start and after move
; At entry: A0 = ID
;	  A1 -> status area
;	  A4 -> working definition

setf	moveq	#48,d2		in/out
	moveq	#0,d0		zero pointer pos
	bsr	rdptrt
	move.l	d1,pos(a6)	keep position
	st	cite(a6)		set no current loose item
	move.w	ww_nlitm(a4),d0	number of loose items
	lea	liset(a6),a5
	bra	setf_1
setf_2	clr.b	(a5)+
setf_1	dbf	d0,setf_2

chkin	moveq	#0,d6		fd = 0
	tst.w	wsp_xpos(a1)
	bmi	chkin_1		not in window
	move.l	pos(a6),ws_ptpos(a1) set ptr pos in status area
	tst.w	wsp_swnr(a1)
	bpl	chkin_1		inside an app window
	move.w	ww_nlitm(a4),d7	no of loose items
	movea.l	ww_plitm(a4),a5	-> loose item list
	bra	chkin_2
chkin_3	move.l	wwl_xorg(a5),d1
	move.l	wwl_xsiz(a5),d2
	lea	wwl_elen(a5),a5
	bsr	isin
	bne	chkin_2		not in this one
	moveq	#1,d6		set "found"
	bra	chkin_8
chkin_2	dbf	d7,chkin_3
	bra	chkin_1
chkin_8	sub.w	ww_nlitm(a4),d7
	neg.w	d7
	subq.w	#1,d7		number of loose item
chkin_1	subq.w	#1,d6		fd - 1
	bne	chkin_5		not in a hit area (fd = 0)
	cmp.w	cite(a6),d7	are we in current item? . .
	beq	chkin_7		. . yes
	bsr	unset
	move.w	d7,cite(a6)	set new current item

; Set the new item's border

	cmpi.b	#$10,ws_litem(a1,d7.w)
	beq	chkin_7
	move.w	d7,ws_citem(a1)
	st	liset(a6,d7.w)
	move.w	ww_lattr+wwa_curw(a4),ws_cibrw(a1)
	move.w	ww_lattr+wwa_curc(a4),ws_cipap(a1)
	move.l	wwl_xsiz-wwl_elen(a5),ws_cihxs(a1)
	move.l	wwl_xorg-wwl_elen(a5),d0
	add.l	ww_xorg(a4),d0
	move.l	d0,ws_cihxo(a1)
	jsr	wm_drbdr(a2)
	move.w	ww_wattr+wwa_papr(a4),ws_cipap(a1)
	rts




; Not in a hit area so unset any borders

chkin_5	st	cite(a6)		mark no item
	bsr	unset
	move.w	#-1,ws_citem(a1)
chkin_7	rts


unset	move.l	a5,-(a7)
	move.w	ww_nlitm(a4),d4
	lea	liset(a6),a5
	bra	unset_3
unset_2	tst.b	(a5)+
	beq	unset_3
	clr.b	-1(a5)
	sub.w	ww_nlitm(a4),d4
	neg.w	d4
	subq.w	#1,d4		0, 1 etc
	move.w	d4,ws_citem(a1)
	bra	unset_4
unset_3	dbf	d4,unset_2
	bra	unset_5
unset_4	bset	#7,ws_citem(a1)
	move.l	ws_ciact(a1),d0	action routine? . .
	beq	unset_1
	bsr	drbdr3
unset_1
	jsr	wm_drbdr(a2)
	bclr	#7,ws_citem(a1)
unset_5	movea.l	(a7)+,a5
	rts


DRBDR3	MOVE.L	A1,-(A7)
	MOVE.L	wsp_xpos(A1),D1
	ADD.L	ww_xorg(A4),D1	Abs pointer pos
	MOVEQ	#1,D2		A "hit"
	MOVEQ	#0,D4
	MOVE.W	WS_CITEM(a1),D0
	bclr	#7,d0
	MULU	#wwl_elen,D0
	ADD.L	ww_plitm(A4),D0
	MOVEA.L	D0,A3		-> loose item
	JSR	WS_CIACT(A1)
	MOVEA.L	(A7)+,A1
	CLR.L	WS_CIACT(A1)
	RTS


; isin sets CC zero if the pointer is in the area d1/d2 (origin/size)

isin	cmp.w	wsp_ypos(a1),d1
	bgt	isin_e
	add.w	d2,d1
	cmp.w	wsp_ypos(a1),d1
	blt	isin_e
	swap	d1
	swap	d2
	cmp.w	wsp_xpos(a1),d1
	bgt	isin_e
	add.w	d2,d1
	cmp.w	wsp_xpos(a1),d1
	blt	isin_e
	move.w	#4,ccr
isin_e	rts

; ldrw draws selected loose items. The type is in D3 (1,or 129).

ldrw	move.b	d3,ws_litem(a1)
	moveq	#-1,d3
	jsr	wm_ldraw(a2)
	bclr	#0,ws_litem(a1)
	rts

afun0_0	bra	*
afun0_1	equ	afun0_0


papert	moveq	#-1,d3
paper	moveq	#sd_setpa,d0
	bsr	tr3
	moveq	#sd_setst,d0
tr3	trap	#3
	tst.l	d0
tr4	bne	sui	---->
	rts

inkt	moveq	#-1,d3
ink	moveq	#sd_setin,d0
	bra	tr3

att	moveq	#-1,d3
at	moveq	#sd_pos,d0
	bra	tr3

overt	moveq	#-1,d3
over	moveq	#sd_setmd,d0
	bra	tr3

clst	moveq	#-1,d3
cls	moveq	#sd_clear,d0
	bra	tr3

blk	move.l	12(a7),d1 	 colour
	lea	block(a6),a1
	moveq	#sd_fill,d0
	bra	tr3

rdptrt	moveq	#-1,d3
rdptr	moveq	#iop_rptr,d0
	addq.l	#8,a1
	bsr	tr3
	subq.l	#8,a1
	rts


	in	win1_ass_pe_ex4w_asm

	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin


	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
