; EX6_asm


	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX6 v1.04"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

id	equ	0
id1	equ	5
wmvec	equ	8
secspc	equ	$0C
color	equ	$10

*
start	lea	(a6,a4.l),a6	dataspace
	move.l	#ww1_0,d1 	size for second window
	bsr	getsp		A0 -> space
	move.l	a0,secspc(a6)	save address
	bsr.s	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#wst0_e-wst0-1,d1	. . and 3 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	move.w	#1,color(a6)
	movea.l	id(a6),a0 	Replace the channel ID
	moveq	#0,d1		default size
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
wrpt	move.w	#300,d3		timeout
	moveq	#0,d2		no event to wait for
	jsr	wm_rptrt(a2)	Read the pointer (with timeout)

	beq.s	no_err
	addq.l	#1,d0
	beq	do_tmout
	bra	sui


*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#-1,d1		. . for this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	rts

; We come here if we exit from wm_rptr without an error
; This means that D4 is non-zero which in turn means either that there
; was a window event (eg CTRL/F4) or that a loose item action routine
; has set a non-zero value in D4. If there was a window event (and no loose
; item) the appropriate bit will have been set in the event vector in the
; status area.

; If a loose item has a select key equal to that for an event, the event
; will not be detected by WM_RPTR since the loose item's action routine
; will have been called instead. The loose item's action routine can then
; set the event bit in the event vector and force an exit from WM_RPTR by
; setting the event number in D4. In that case the following code would be
; used. On the other hand the loose item's action routine could process the
; event internally without exiting from WM_RPTR.

no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit
	btst	#pt__move,wsp_weve(a1)
	beq.s	no_er2
	bsr	move
	bra	wrpt
no_er2	btst	#pt__zzzz,wsp_weve(a1)
	beq	wrpt
sleep1	move.l	#ww0_1,d1 	sleep size
	move.l	#ww0_0,d2 	main window size
	bsr	sleep
	move.w	color(a6),d0
	move.b	crs(d0.w),ww_wattr+wwa_papr+1(a4)
	jsr	wm_wrset(a2)
	jsr	wm_wdraw(a2)
	bra.s	wrpt		read pointer again

; Colours l_red, d_red, l_green, d_green, mustard, grey

crs	dc.b	234,210,220,228,242,255

; Loose item action routines

; MOVE

afun0_0	bsr	move
af1	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	     available
	moveq	#0,d4
	moveq	#0,d0
	rts


; EXIT

afun0_1	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts

; Action (change colour)

afun0_2	bsr	action
	bra	af1


action	move.w	color(a6),d0
	subq.w	#5,d0
	beq	af02_1
	addq.w	#6,d0
af02_1	move.w	d0,color(a6)
	move.b	crs(d0.w),ww_wattr+wwa_papr+1(a4)
	jsr	wm_wrset(a2)
	jmp	wm_wdraw(a2)


do_tmout	movea.l	(a4),a1		-> status area
	movea.l	a4,a5		keep working definition
	tst.w	wsp_swnr(a1)
	bpl	wrpt		nothing to do
	move.w	ws_citem(a1),d7	loose item number
	bmi	wrpt		not a loose item
	move.w	#wst3_e-wst1-1,d0
	lea	wst1,a1		clear . .
dot_1	clr.b	(a1)+		. . all . .
	dbf	d0,dot_1		. . 2nd window status areas
	move.w	d7,d1
	add.w	d1,d1
	lea	slist,a1
	lea	(a1,d1.w),a1
	adda.w	(a1),a1		-> status area
	lea	wdlst,a3
	lea	(a3,d1.w),a3
	adda.w	(a3),a3		-> window definition
	movea.l	secspc(a6),a4	space for 2nd window
	moveq	#0,d1		default size
	jsr	wm_setup(a2)
	moveq	#-1,d1		at cursor
	jsr	wm_pulld(a2)
	move.l	a0,id1(a6)	save ID
	jsr	wm_wdraw(a2)	draw the window

	moveq	#48,d2
	moveq	#0,d0
	moveq	#-1,d3
	moveq	#iop_rptr,d0
	addq.l	#8,a1
	trap	#3		find the current pointer position
	subq.l	#8,a1
	move.l	d1,d6
	moveq	#-1,d5		mark "nothing to do"
	moveq	#11,d2		wait for keypress or movement
	moveq	#iop_rptr,d0
	addq.l	#8,a1
	trap	#3
	subq.l	#8,a1
	cmp.l	d1,d6		movement? . .
	bne	dot_2		. . yes
	move.b	wsp_kstr(a1),d0	keystroke
	cmpi.b	#1,d0
	beq	dot_3		set d5=d7
	cmpi.b	#2,d0
	bne	dot_4
dot_3	move.w	d7,d5		set d5 = item number
	bra	dot_2
dot_4
	cmpi.b	#27,d0		ESC
	beq	dot_5		set 1
	cmpi.b	#245,d0		CTRL/F4 (move)
	beq	dot_8		set 0
	cmpi.b	#"A",d0
	beq	dot_7		set 2
	cmpi.b	#"a",d0
	beq	dot_7		set 2 for ACTION
	cmpi.b	#233,d0		CTRL/F1 (sleep)
	bne	dot_2		do nothing
	addq.w	#1,d5		set 3
dot_7	addq.w	#1,d5
dot_5	addq.w	#1,d5
dot_8	addq.w	#1,d5

; At this point D5.W = -1 for do nowt, 0 for MOVE, 1 for ESC, 2 for ACTION
; and 3 for SLEEP.
; We have to throw away the second wondow and do any necessary thing

dot_2	jsr	wm_unset(a2)
	movea.l	id1(a6),a0	2nd channel ID
	moveq	#io_close,d0
	trap	#2		close it
	movea.l	a5,a4		replace the working definition
	movea.l	(a4),a1		set A1 to status area
	tst.w	d5
	bmi	wrpt
	subq.w	#1,d5
	bmi	dot_6		move
	beq	sui		ESC
	subq.w	#1,d5
	bne	sleep1
	bsr	action
	bra	wrpt		go back to read the pointer
dot_6	bsr	move
	bra	wrpt


papert	moveq	#-1,d3
paper	moveq	#sd_setpa,d0
	bsr	tr3
	moveq	#sd_setst,d0
tr3	trap	#3
	tst.l	d0
tr4	bne	sui	---->
	rts

inkt	moveq	#-1,d3
ink	moveq	#sd_setin,d0
	bra	tr3

att	moveq	#-1,d3
at	moveq	#sd_pos,d0
	bra	tr3

overt	moveq	#-1,d3
over	moveq	#sd_setmd,d0
	bra	tr3

clst	moveq	#-1,d3
cls	moveq	#sd_clear,d0
	bra	tr3

utm	movea.w	ut_mtext,a2
	jsr	(a2)
	bra	tr4



wdlst	dc.w	wd1-*
	dc.w	wd2-*
	dc.w	wd3-*


slist	dc.w	wst1-*
	dc.w	wst2-*
	dc.w	wst3-*

	in	win1_ass_pe_ex6w_asm

	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin

	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
