; EX7_asm
	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX7 v1.02"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

id	equ	0
id1	equ	4
wmvec	equ	8
secspc	equ	12

*
start	lea	(a6,a4.l),a6	dataspace
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#$70,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#wst0_e-wst0-1,d1	. . and 4 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	movea.l	id(a6),a0 	Replace the channel ID
	moveq	#0,d1		default size
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
wrpt	jsr	wm_rptr(a2)	Read the pointer

	beq	no_err
	bra	sui


*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#0,d3
ope1	moveq	#-1,d1		. . for this job
	moveq	#io_open,d0
	trap	#2
	rts

; We come here if we exit from wm_rptr without an error
; This means that D4 is non-zero which in turn means either that there
; was a window event (eg CTRL/F4) or that a loose item action routine
; has set a non-zero value in D4. If there was a window event (and no loose
; item) the appropriate bit will have been set in the event vector in the
; status area.

; If a loose item has a select key equal to that for an event, the event
; will not be detected by WM_RPTR since the loose item's action routine
; will have been called instead. The loose item's action routine can then
; set the event bit in the event vector and force an exit from WM_RPTR by
; setting the event number in D4. In that case the following code would be
; used. On the other hand the loose item's action routine could process the
; event internally without exiting from WM_RPTR.


no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit
	btst	#pt__move,wsp_weve(a1)
	beq.s	noe
	bsr	move
noe	moveq	#0,d4		mark no event . .
	moveq	#0,d0		. . and no error
	bra.s	wrpt		read pointer again


; Loose item action routines

; MOVE

afun0_0	bsr	move
af1	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	     available
	moveq	#0,d4
	moveq	#0,d0
	rts

afun2_0	equ	afun0_0

; RESIZE

afun2_1	move.l	a3,-(a7)
	movea.l	ww_wdef(a4),a3	window definition
	bsr.s	resze
	movea.l	(a7)+,a3		restore pointer to loose item
	bra.s	af1

resze	move.l	ww_xorg(a4),d7
	move.l	ww_wdef(a4),a5	window def
	add.l	wd_xorg(a5),d7
	add.w	ww_ysize(a4),d7	ptr position for PRPOS (optr)
	bset	#pt__wsiz,wsp_weve(a1)
	jsr	wm_chwin(a2)	sets change to D1 (mv)
	bclr	#pt__wsiz,wsp_weve(a1)
	move.w	wd_rbase+wd_xmin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_xsize(a4),d4
	swap	d1
	add.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze1		d4 is greater
	move.w	d5,d4
resze1	move.w	wd_xsize(a5),d5
	cmp.w	d5,d4
	blt.s	resze2		d4 is smaller
	move.w	d5,d4
resze2	moveq	#1,d3
	add.w	d4,d3
	bclr	#0,d3		keep answer in D3.W  (mv)
	move.w	wd_rbase+wd_ymin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_ysize(a4),d4
	swap	d1
	sub.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze3		d4 is greater
	move.w	d5,d4
resze3	move.w	wd_ysize(a5),d5
	cmp.w	d5,d4
	blt.s	resze4		d4 is smaller
	move.w	d5,d4
resze4	swap	d3
	move.w	d4,d3		D3 = new mv x | y
	jsr	wm_unset(a2)
	bsr	rechp		throw away wk def in A4
	movea.l	id1(a6),a0
	moveq	#io_close,d0
	trap	#2
	move.l	d3,d1		new size
	jsr	wm_fsize(a2)
	move.l	d1,-(a7)		keep size pro tem
	move.l	#ww1_0,d1 	space needed
	bsr	getsp
	move.l	(a7)+,d1		replace size
	movea.l	a0,a4		new wwd
	movea.l	id1(a6),a0	replace ID
	jsr	wm_setup(a2)
;
; The position for PULLD is optr-newy with minimum of 4 | 2
;
	move.l	d7,d1
	swap	d1
;	 swap	 d3
;	 sub.w	 d3,d1
	cmpi.w	#4,d1
	bge.s	resze5		D1 not less than 4
	move.w	#4,d1		set minimum of 4
resze5	swap	d1
;	 swap	 d3
	sub.w	d3,d1
	cmpi.w	#2,d1
	bge.s	resze6		D1 not less than 2
	move.w	#2,d1		set minimum of 2
resze6	jsr	wm_pulld(a2)
	move.l	a0,id1(a6)
	jmp	wm_wdraw(a2)





; EXIT

afun0_1	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts


afun2_2	equ	afun0_1

; Second

afun0_2	movem.l	a0-4,-(a7)
	move.l	#ww1_0,d1 	size for second window
	bsr	getsp		A0 -> space
	move.l	a0,secspc(a6)	save address
	moveq	#wst1_e-wst1-1,d0
	lea	wst1,a1
af02_1	clr.b	(a1)+
	dbf	d0,af02_1 	clear status area
	movea.l	id(a6),a0
	moveq	#0,d1		default size (the only one!)
	lea	wst1,a1		status area
	lea	wd1,a3		second window definition
	movea.l	secspc(a6),a4	space for working definition
	jsr	wm_setup(a2)	set working definition
	moveq	#-1,d1		at cursor
	jsr	wm_pulld(a2)
	move.l	a0,id1(a6)
	jsr	wm_wdraw(a2)	draw the window
wrpt1	jsr	wm_rptr(a2)	read the pointer
	beq	no_erra		no error at the 2nd window
	bra	sui	---->

no_erra	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	beq	no_erra1
	jsr	wm_unset(a2)
	bsr	rechp		throws away A4 wk def
	movea.l	id1(a6),a0
	moveq	#io_close,d0
	trap	#2
	movem.l	(a7)+,a0-4

;	 move.w	 ws_citem(a1),d1
	moveq	#2,d1		3rd loose item

	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	available
	rts

no_erra1	moveq	#0,d4
	moveq	#0,d0
	bra	wrpt1

	in win1_ass_pe_EX7w_asm






RECHP	EQU   *+$00000298
GETSP	EQU   *+$00000284
SUI	EQU   *+$000002CE
MOVE	EQU   *+$000002B8

sleep	lib	win1_ass_pe_sleep_bin

	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
